<?php
/* this script should be included right after:
 * require_once('../lib-common.php');
 * -------------------------------------------------
 */

if (strpos(strtolower($_SERVER['PHP_SELF']), 'proxy.php') !== false) {
    die('This file can not be used on its own!');
}

include_once 'classes/glPage.class.php';
include_once 'classes/exception/glErrorHandler.class.php';

function glUncaughtExceptionHandler(Exception $e) {
    static $handler = null;
    if ($handler === null) {
        $handler = glErrorHandler::getInstance();
    }
    $handler->handleError(256, $e->getMessage(), $e->getFile(), $e->getLine(), $GLOBALS['_PAGE']);
}

/* main actions: 
 * -------------------------------------------------
 */
set_exception_handler('glUncaughtExceptionHandler');

glPage::setOutline('geeklog');
glPage::setCssSelectorNS('gl');
$GLOBALS['_PAGE'] = glPage::getNode('geeklog');

/* end of main actions
 * -------------------------------------------------
 */

function value_dump($var, $max_scope = 10, $indent = "\n") {
    $indent .= "  ";
    $result = "";
    if (is_null($var)) {
        $result .= "(null)";
    }
    elseif (is_object($var)) {
        $result .= "(object) {".get_class($var)."} (";
        if ($max_scope != 0) {
            $properties = array_keys(get_object_vars($var));
            foreach ($properties as $name) {
                if (is_object($var-> $name) and $max_scope > 2) {
                    $max_scope = 2;
                }
                $result .= $indent."\$".$name.' = ';
                $result .= value_dump($var-> $name, $max_scope -1, $indent).",";
            }
        } else {
            $result .= $indent.'/* ... */';
        }
        $result .= $indent.")";
    }
    elseif (is_array($var)) {
        $result .= "array(";
        if ($max_scope != 0) {
            foreach ($var as $key => $value) {
                if (is_string($key)) {
                    $key = "'".$key."'";
                }
                $result .= $indent.$key." => ";
                $result .= value_dump($value, $max_scope -1, $indent).",";
            }
        } else {
            $result .= $indent.'/* ... */';
        }
        $result .= $indent.")";
    }
    elseif (is_string($var)) {
        $result .= '(string) "'.htmlspecialchars(hidePath($var)).'"';
    }
    elseif (is_bool($var)) {
        $result .= '(boolean) '. (($var) ? 'true' : 'false');
    } else {
        $result .= '('.gettype($var).') '.$var;
    }
    return $result;
}
function hidePath($string) {
    if (!is_string($string)) {
        return $string;
    }
    global $_CONF;

    $string = str_replace($_CONF['path'],        '.....', $string);
    $string = str_replace($_CONF['path_system'], '.....', $string);
    $string = str_replace($_CONF['path_layout'], '.....', $string);
    $string = str_replace($_CONF['site_url'] ,   '.....', $string);
    return $string;
}

?>